//KEVAtB^

/* 2003.12.14
   ύX_
   Estatic,final قƂǖɁD
   Eweight\bh̍쐬iƂstatic)
   EFilterPanelNXgetFilterPanel\bh̍쐬
*/

package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class FilterGaussian extends Filter
{
    private int windowSize = 7,	//EBhETCY(ł邱)
	windowSizeMax = 35,
	windowSizeMin = 1;
    
    private double SIGMA = 3.0,	//ڂɉe
	SIGMAMax = 1000.0,
	SIGMAMin = 0.0001;
	
    //L̓ύX΁AɏC̕Kv͂Ȃ
	
	
	
    private int offset = (windowSize-1) / 2;
    private double ND[][] = new double[offset*2+1][offset*2+1];
	
    //ď݂vZ
    void weight(){
	int size = offset*2+1;
	double t[] = new double[size];
	final double k = 1.0 / Math.sqrt(2.0 * Math.PI) / SIGMA;
	double total = 0.0;
	for (int i=0; i<size; i++) {
	    double x = i - offset;
	    t[i] = k / Math.exp( x * x / (2 * SIGMA * SIGMA) );
	    total += t[i];
	}
	for (int i=0; i<size; i++) t[i] /= total;
	for (int i=0; i<size; i++) {
	    for (int j=0; j<size; j++) {
		ND[i][j] = t[i] * t[j];
	    }
	}
    }
	

    //̃tB^̖̂Ԃ
    public String getName()
    {
	int size = offset*2+1;
	return "Gaussian";
    }
	
    //摜̃tB^O
    public void filter(AnimatedImage AI)
    {
	weight();
	
	double total, sumR, sumG, sumB;
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		total = sumR = sumG = sumB = 0.0;
		if ( x-offset<0 || x+offset>=AI.getWidth() 
		     || y-offset<0 || y+offset>=AI.getHeight() ) {	//ʂ̒[̕
		    for (int ix=-offset; ix<=offset; ix++) {
			for (int iy=-offset; iy<=offset; iy++) {
			    if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) continue;
			    total += ND[ix+offset][iy+offset];
			    sumR += AI.getR( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumG += AI.getG( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumB += AI.getB( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			}
		    }
		    sumR /= total;  sumG /= total;  sumB /= total;  
		} else {		//ʂ̒
		    for (int ix=-offset; ix<=offset; ix++) {
			for (int iy=-offset; iy<=offset; iy++) {
			    sumR += AI.getR( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumG += AI.getG( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumB += AI.getB( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			}
		    }
		}
		AI.setRGB( x, y, (int)Math.rint(sumR), (int)Math.rint(sumG), (int)Math.rint(sumB) );
	    }
	    this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;
    }


    /* vύX_ */
    /* ʏ̃tB^ɉĈȉ̓Ă */

    class FilterGaussianPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Gaussian parameter"),
	    L2 = new Label("sigma "),
	    L3 = new Label("Window Size");
	TextField T1 = new TextField(""+SIGMA,5),
	    T2 = new TextField(""+windowSize,5);
	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,100,1,0,1000),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,(windowSize-1)/2,3,0,20);

	FilterGaussianPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    try{
		windowSize = Integer.parseInt(T2.getText());
	    }catch(NumberFormatException e){}
	    if(windowSize > windowSizeMax) windowSize = windowSizeMax;
	    if(windowSize < windowSizeMin) windowSize = windowSizeMin;
	    T2.setText(""+windowSize);
	    try{
		SIGMA = Double.parseDouble(T1.getText());
	    }catch(NumberFormatException e){}
	    if(SIGMA > SIGMAMax) SIGMA = SIGMAMax;
	    if(SIGMA < SIGMAMin) SIGMA = SIGMAMin;
	    T1.setText(""+SIGMA);
	    offset = (windowSize-1) / 2;
	    ND = new double[offset*2+1][offset*2+1];
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val/10.0);
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+(val*2+1));
	    }
	}  
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  FilterGaussianPanel();
    }
}
