//쥻ԥե륿¤ޤ

package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class FilterSepia extends Filter
{   
    AnimatedImage ai;
    SepiaData sepiaData = new SepiaData();
    
    private int R = 240,    //ͤѿ
        RMax = 256,
        RMin = 0;           

    private int G = 200,    //ͤѿ
        GMax = 256,
        GMin = 0;           
    
    private int B = 145,    //ͤѿ
        BMax = 256,
        BMin = 0;           
    
    public String getName()
    {
        return "Sepia";     //ե륿̾
    }
  
    public SepiaData getSepiaData()
    {
        return sepiaData;
    }
    
    public void filter(AnimatedImage AI)   //ե륿򤫤
    { 
	
	for( int y=0; y<AI.getHeight(); y++ )
	    {
		for( int x=0; x<AI.getWidth(); x++ )
		    {
			//sepia
			int  r = AI.getR( x, y );
			int  g = AI.getG( x, y );
			int  b = AI.getB( x, y );
			double Y = getY( r, g, b );  //NTSCϲýʿˡ굱٤
			
			r = getSepiaR( Y );
			g = getSepiaG( Y );
			b = getSepiaB( Y );
			
			AI.setRGB( x, y, r, g, b );
		    }
		
		this.switchThread();
	    }
	
	this.switchThread();    //ѹʬ̤ȿǤ
	AI.repaintAll();
	
	ai = AI;
	return; 
        
    }
    
    public void reDraw()
    {
        if( ai == null )
            return;
	
        
        int tempW = ai.getWidth();
        int tempH = ai.getHeight();
        int maxDistance = ( tempW < tempH ) ? tempW/2 : tempH/2;
        
        for( int y=0; y<ai.getHeight(); y++ )
            {
                for( int x=0; x<ai.getWidth(); x++ )
                    {
                        //sepia
                        
                        int r = ai.getR( x, y );
                        int g = ai.getG( x, y );
                        int b = ai.getB( x, y );
                        double Y = getY( r, g, b );//NTSCϲýʿˡ굱٤
                        
                        //ǤȤε٤
                        Y = sepiaData.getY( Y );
                        
                        //ֶᤤդεΥ
                        //int distanceFromEdge = getDistanceFromEdge( tempW, tempH, x, y );
                        //դεΥ˱Ƶ٤Ѥ
                        //Y = fadeData.getFadeY( Y, distanceFromEdge, maxDistance );
                        
                        //پ󤫤RGBͤѴ
                        r = getSepiaR( Y );
                        g = getSepiaG( Y );
                        b = getSepiaB( Y );
                        
                        ai.setRGB( x, y, r, g, b);
                    }
                
                //this.switchThread();
            }
        
        this.switchThread();    //ѹʬ̤ȿǤ
        ai.repaintAll();
        
        return; 
    }
    
    //Y饻ԥRGB
    public int getSepiaR( double y )
    {
        return (int)( y * ( sepiaData.getR() / 255.0 ) );
    }
    
    public int getSepiaG( double y )
    {
        return (int)( y * ( sepiaData.getG() / 255.0 ) );
    }
    
    public int getSepiaB( double y )
    {
        return (int)( y * ( sepiaData.getB() / 255.0 ) );
    }
    
    //RGBYUV
    public double getY( int R, int G, int B )
    {
        return 0.298912*R + 0.586611*G + 0.114478*B;
    }
    
    public double getU( int R, int G, int B )
    {
        return -0.147 * R - 0.289 * G + 0.436 * B;
    }
    
    public double getV( int R, int G, int B )
    {
        return 0.615 * R - 0.515 * B - 0.100 * B;
    }
    
    //YUVRGB
    public double getR( double y, double u, double v )
    {
        return y + 0.000 * u + 1.140 * v;
    }
    
    public double getG( double y, double u, double v )
    {
        return y - 0.396 * u - 0.581 * v;
    }
    
    public double getB( double y, double u, double v )
    {
        return y + 2.029 * u + 0.000 * v;
    }
    
    class SepiaData
    {
        private double y;  //0.0(㤤)255.0()
        private int r;
        private int g;
        private int b;
     
	SepiaData(){
	    y = 0.0;   //٤ν
	} 

	public double getY( double y )	{
	   
	    if( y + this.y > 255 )
		return 255;
	    else if( y + this.y < 0 )
		return 0;
	    else
	    return y + this.y;
	}
	
	public int getR()
	{
	    return R;  //ѥ᡼ѿҤ֤
	}
	
	public int getG()
	{
	    return G;  //ѥ᡼ѿǤ֤
	}
	
	public int getB()
	{
	    return B;  //ѥ᡼ѿ¤֤
	}
	
	public void setY( double y )
	{
	    this.y = y;
	}
	
	public void setR( int R )
	{
		this.r = R;   //ѥ᡼ѿҤ֤
	}
	
	public void setG( int G )
	{
		this.g = G;   //ѥ᡼ѿǤ֤
	}
	
	public void setB( int B )
	{
		this.b = B;   //ѥ᡼ѿ¤֤
	}
    }
    
    class FilterSepiaPanel extends FilterPanel implements AdjustmentListener
    {
	//ʲǥѥ᡼Ԥʤ
	
	Label L1 = new Label("Sepia parameter"),  //٥̾
	    L2 = new Label("R"),
	    L3 = new Label("G"),
	    L4 = new Label("B");	    
	TextField T1 = new TextField(""+R,5),    //ƥȥե
	    T2 = new TextField(""+G,5),
	    T3 = new TextField(""+B,5);
	Scrollbar 
	    S1 = new Scrollbar(Scrollbar.HORIZONTAL,240,1,0,256),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,200,1,0,256),
	    S3 = new Scrollbar(Scrollbar.HORIZONTAL,145,1,0,256);
        	//͡Ļ̡Ǿ͡
	
	FilterSepiaPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);
	    this.add(this.L4);
	    this.add(this.S3);
	    this.add(this.T3);
	    
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	    
	} 
	
	public void setFilterParameter()
	{
	    try{
		B = Integer.parseInt(T3.getText());
	    }
	    catch(NumberFormatException e){}
	    if(B > BMax) B = BMax;
	    if(B < BMin) B = BMin;
	    T3.setText(""+B);
	    try{
		G = Integer.parseInt(T2.getText());
	    }
	    catch(NumberFormatException e){}
	    if(G > GMax) G = GMax;
	    if(G < GMin) G = GMin;
	    T2.setText(""+G); 
	    try{
		R = Integer.parseInt(T1.getText());
	    }
	    catch(NumberFormatException e){}
	    if(R > RMax) R = RMax;
	    if(R < RMin) R = RMin;
	    T1.setText(""+R); 
	    
	}
	
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val);
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+val);
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+val);
	    }
	    
	} 
	
    }
    
    public FilterPanel getFilterPanel()
    {
	return new  FilterSepiaPanel();
    }
}

