package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
 * SobeltB^
 */
public class FilterSobel extends Filter 
{
	
    //3x3  5x5 ̂ǂ炩̃tB^IARgAEg
	
    /**
     *  "optimal" 5x5 Filterp
     *   mCYEɂ
     */
    private static final double p5[] = {0.036470, 0.248968, 0.429123, 0.248968, 0.036470};
    private static final double d5[] = {-0.108385, -0.280349, 0.0, 0.280349, 0.108385};
    private static final double Fx5[][] = {{p5[0]*d5[0], p5[0]*d5[1], p5[0]*d5[2], p5[0]*d5[3], p5[0]*d5[4]},
					   {p5[1]*d5[0], p5[1]*d5[1], p5[1]*d5[2], p5[1]*d5[3], p5[1]*d5[4]},
					   {p5[2]*d5[0], p5[2]*d5[1], p5[2]*d5[2], p5[2]*d5[3], p5[2]*d5[4]},
					   {p5[3]*d5[0], p5[3]*d5[1], p5[3]*d5[2], p5[3]*d5[3], p5[3]*d5[4]},
					   {p5[4]*d5[0], p5[4]*d5[1], p5[4]*d5[2], p5[4]*d5[3], p5[4]*d5[4]}};
    private static final double Fy5[][] = {{d5[0]*p5[0], d5[0]*p5[1], d5[0]*p5[2], d5[0]*p5[3], d5[0]*p5[4]},
					   {d5[1]*p5[0], d5[1]*p5[1], d5[1]*p5[2], d5[1]*p5[3], d5[1]*p5[4]},
					   {d5[2]*p5[0], d5[2]*p5[1], d5[2]*p5[2], d5[2]*p5[3], d5[2]*p5[4]},
					   {d5[3]*p5[0], d5[3]*p5[1], d5[3]*p5[2], d5[3]*p5[3], d5[3]*p5[4]},
					   {d5[4]*p5[0], d5[4]*p5[1], d5[4]*p5[2], d5[4]*p5[3], d5[4]*p5[4]}};

    /**
     * 3x3 Sobel Filter
     */
    private static final double Fx3[][] = {{-0.25,   0.0,  0.25},
					   {-0.50,   0.0,  0.50},
					   {-0.25,   0.0,  0.25}};
    private static final double Fy3[][] = {{-0.25, -0.50, -0.25},
					   {  0.0,   0.0,   0.0},
					   { 0.25,  0.50,  0.25}};

    double Fx[][] = Fx5;
    double Fy[][] = Fy5;
	
    /** 
     * xNg̑傫ʓx▾邳ɕϊ邽߂̌W
     *   傫قǑN₩AmCYEՂ
     */
    double K_SB = 1.0 / 16.0;
	
    /** PxvẐ߂̌W */
    double k[] = {0.3, 0.59, 0.11};
    /** tB^TCY̔ */
    int offset = Fx.length/2;
	
	
	
    /** tB^̖̂Ԃ */
    public String getName()
    {
	return "Sobel";
    }
	
    /** 摜̃tB^O */
    public void filter(AnimatedImage AI)
    {
	offset = Fx.length/2;
	double dx, dy, dR, dG, dB, L, H, S, B, theta, phi;
	AI.repaintAll();
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		if ( x-offset<0 || x+offset>=AI.getWidth() || y-offset<0 || y+offset>=AI.getHeight() ) {
		    //ʂ̒[̕
		    AI.setRGB( x, y, 0, 0, 0 );
		    continue;
		}
		dR = dG = dB = 0.0;
		for (int iy=-offset; iy<=offset; iy++) {
		    for (int ix=-offset; ix<=offset; ix++) {
			dR += AI.getR(x+ix, y+iy) * Fx[iy+offset][ix+offset];
			dG += AI.getG(x+ix, y+iy) * Fx[iy+offset][ix+offset];
			dB += AI.getB(x+ix, y+iy) * Fx[iy+offset][ix+offset];
		    }
		}
		dx = k[0]*dR + k[1]*dG + k[2]*dB;
		dR = dG = dB = 0.0;
		for (int iy=-offset; iy<=offset; iy++) {
		    for (int ix=-offset; ix<=offset; ix++) {
			dR += AI.getR(x+ix, y+iy) * Fy[iy+offset][ix+offset];
			dG += AI.getG(x+ix, y+iy) * Fy[iy+offset][ix+offset];
			dB += AI.getB(x+ix, y+iy) * Fy[iy+offset][ix+offset];
		    }
		}
		dy = k[0]*dR + k[1]*dG + k[2]*dB;
				
				//xNgpxɕϊ
		L = Math.sqrt(dx*dx+dy*dy);
		theta = Math.acos( dx / L );
		phi = Math.asin( dy / L );
		if ( phi < 0 ) theta = 2.0*Math.PI - theta;
		H = theta / (2.0 * Math.PI);
		S = 1.0;
		B = L * K_SB;
		if ( B > 1.0 ) B = 1.0;
		int RGBvalue = java.awt.Color.HSBtoRGB( (float)H, (float)S, (float)B );
		AI.setRGB( x, y, 
			   ((RGBvalue & 0x00FF0000) >> 16), 
			   ((RGBvalue & 0x0000FF00) >> 8), 
			   (RGBvalue & 0x000000FF) );
	    }
	    this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;
    }
	    
    class FilterSobelPanel extends FilterPanel {

	Label L1 = new Label("Sobel"),
	    L2 = new Label("RANGE 5 3");
	

	CheckboxGroup g = new CheckboxGroup();
	Checkbox
	    cb1 = new Checkbox("5",g, true),
	    cb2 = new Checkbox("3", g,false);

	FilterSobelPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.cb1);
	    this.add(this.cb2);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    Checkbox tmp=g.getSelectedCheckbox();
	    if(tmp == cb1){
		Fx = Fx5;
		Fy = Fy5;
	    }else if(tmp == cb2){
		Fx = Fx3;
		Fy = Fy3;
	    }
	}
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  FilterSobelPanel();
    }
}
