package imageFiltering.filter;

import imageFiltering.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

////////////////////////////////////////////////////////////////////////////////
//
// {mC̃tB^	by Hiroshi Kuwabara 2003/01/26
//
public class FilterVoronoi extends Filter
{
    private DiscreteVoronoi dv;	// U{mC
    private Point kp[];         // _W
    private int width;		// 摜̕
    private int height;		// 摜̍
    //private AverageColor ac[];  // RGBl̕
    private AnimatedImage baseAI;       // x[X摜
    //private AnimatedImage voronoiAI;    // {mC摜

    public static final int MAXNUM = 20000;     // _̍ől
    private static final int KPNUM = 500;       // _̏l
    private static final int KPSPACE = 10;      // _ԊԊȕl
    private static final int THRE_CELL = 10;    // ZpXVhl̏l
    
    public static final int STATENUM = 2;       // ʎw       
    public static final int RANDOM   = 0;       // __zu̎ʎq
    public static final int LATTICE  = 1;       // iq_zu̎ʎq
    public static final int ADAPTIVE = 2;       // A_veBԂȕ_zu̎ʎq
    
    public static final int KINDNUM = 1;        // {mC𗘗p摜̎ސ
    public static final int CELL    = 0;        // Z敗
    
    private int num;         // _
    private int space;       // _ԊԊu
    private int KPFLAG;      // _zu̎ʃtO
    private int thre_cell;  // Zp臒l(threshold)
    private boolean BorderLine; // E`ǂ̎ʃtO

    public FilterVoronoi() {
	// 
	// initParam(KPNUM);
	num = KPNUM;
        space = KPSPACE;
        KPFLAG = RANDOM;                // ŏ̓__zu
	thre_cell = THRE_CELL;
        kp = new Point[MAXNUM];
        BorderLine = false;
        /*
	// ̃C^[tFCX
	Frame f = new Frame();
	f.setSize(500,500);
	Panel p = new Panel();
	p.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
	ta = new TextArea(300,300);
	p.add(ta);
	tf = new TextField((new Integer(num)).toString(), 5);
	tf.addActionListener(this);
	p.add(tf);
	Button b = new Button("Draw");
	b.addActionListener(this);
	p.add(b);
	f.add(p);
	//f.show();
         */
    }
    
    // tB^plp[^lZbg郁\bh
    public void setParam(int kpnum, int kpspace ,int kpflag,boolean borderline) {
        this.num = kpnum;
        this.space = kpspace;
        this.KPFLAG = kpflag;
        this.BorderLine = borderline;
    }
    
    public void setBorderLine(boolean borderline) {
        this.BorderLine = borderline;
    }
    
    // Z敗̉摜̕`p臒lZbg郁\bh
    public void setThresholdforCell(int thre_cell) {
        this.thre_cell = thre_cell;
    }
    
    // ep[^̏
    private void initParam(int N) {
	num = N;
	//ac = new AverageColor[num];
	//for (int i=0; i<num; i++) {
	//    ac[i] = new AverageColor();
	//}
    }
    
    //------------------------------------------------------------------------//
    // ȉ͕_^邽߂̃\bhQ
    //------------------------------------------------------------------------//
    // _̍W_ɗ^
    private void randomKernelPoint() {
	Random r = new Random();
        for (int i=0; i<num; i++) {
	    kp[i] = new Point(r.nextInt(width),r.nextInt(height));
	}
    }

    // _iqɗ^
    private int latticeKernelPoint(int kpspace) {
	try {
            int n=0;
            double dy=kpspace*Math.sqrt(3);    // y̑
            int j;
            for (j=0; j*dy < height; j++) {
                int i;
                for (i=0; (i*kpspace*2+kpspace*(j%2)) < width; i++) {
                    kp[n] = new Point((int)(i*kpspace*2+kpspace*(j%2)),(int)(j*dy));
                    n++;
                }
                kp[n] = new Point((int)(i*kpspace*2+kpspace*(j%2)),(int)(j*dy));    // 1񕪑߂ɕ_𐶐
                n++;
            }
            for (int i=0; (i*kpspace*2+kpspace*(j%2)) < width; i++) {    // 1s߂ɕ_𐶐
                kp[n] = new Point((int)(i*kpspace*2+kpspace*(j%2)),(int)(j*dy));
                n++;
            }
            return n;
        } catch (Exception e) {
            /*
            ErrorFrame ef = new ErrorFrame("Error Dialog!!!");
            ef.show();
            ef.setSize(300,200);
            ef.setErrorMessage("_ő_𒴂Ă܂܂I");
             */
            return -1;
        }
    }
    
    // A_veBuɕ_^
    private int adaptiveKernelPoint(AnimatedImage AI) {
        int width = AI.getWidth();
        int height = AI.getHeight();
        int kpnum = 0;
        int d_sites = 5;
        int d_min = 2;
        int t_imp = 100;
        boolean Occ[][] = new boolean[width][height];
        int Imp[][];
        double Dist[][] = new double[width][height];
        Vector edge = new Vector();
        //Point Edge[] = new Point[width*height];
        Gradient grad = new Gradient(AI);
        // Occ(p)̏ ------------------------------------------------------
        for (int j=0; j<height; j++)
            for (int i=0; i<width; i++)
                Occ[i][j] = true;
        // Imp(p)̏ ------------------------------------------------------
        Imp = grad.getGradientValue();
        // Dist(p)̏ -----------------------------------------------------
        // ܂GbW̍W擾
        //int enum = 0;
        for (int j=0; j<height; j++)
            for (int i=0; i<width; i++)
                if (Imp[i][j] >= t_imp)
                    //Edge[enum++] = new Point(i,j);
                    edge.add(new Point(i,j));
        int min_id = 0;
        int pre_id = 0;
        /*
        for (int j=0; j<height; j++) {
            for (int i=0; i<width; i++) {
                double d;
                double dx=Edge[pre_id].x-i;
                double dy=Edge[pre_id].y-j;
                double min_d=Math.sqrt(dx*dx+dy*dy);
                for (int k=pre_id-1; k>=0 && (Edge[k].y>=j-min_d);k--) {
		    if (Edge[k].x >= i && Edge[k].x <= i+min_d) {
                        dx=Edge[k].x-i;
                        dy=Edge[k].y-j;
                        d=Math.sqrt(dx*dx+dy*dy);
                        if (d<min_d) {
                            min_id=k;
                            min_d=d;
                        }
                    }
		}
                for (int k=pre_id+1; k<enum && (Edge[k].y<=j+min_d);k++) {
                    if (Edge[k].x >= i && Edge[k].x <= i+min_d) {
                        dx=Edge[k].x-i;
                        dy=Edge[k].y-j;
                        d=Math.sqrt(dx*dx+dy*dy);
                        if (d<min_d) {
                            min_id=k;
                            min_d=d;
                        }
                    }
                }
                Dist[i][j] = min_d;
                pre_id = min_id;         // OID
	    }
        }
         */
        for (int j=0; j<height; j++) {
            for (int i=0; i<width; i++) {
                double d;
                double dx=((Point)edge.elementAt(pre_id)).x-i;
                double dy=((Point)edge.elementAt(pre_id)).y-j;
                double min_d=Math.sqrt(dx*dx+dy*dy);
                for (int k=pre_id-1; k>=0 && (((Point)edge.elementAt(k)).y>=j-min_d);k--) {
		    if (((Point)edge.elementAt(k)).x >= i && ((Point)edge.elementAt(k)).x <= i+min_d) {
                        dx=((Point)edge.elementAt(k)).x-i;
                        dy=((Point)edge.elementAt(k)).y-j;
                        d=Math.sqrt(dx*dx+dy*dy);
                        if (d<min_d) {
                            min_id=k;
                            min_d=d;
                        }
                    }
		}
                for (int k=pre_id+1; k<edge.size() && (((Point)edge.elementAt(k)).y<=j+min_d);k++) {
                    if (((Point)edge.elementAt(k)).x >= i && ((Point)edge.elementAt(k)).x <= i+min_d) {
                        dx=((Point)edge.elementAt(k)).x-i;
                        dy=((Point)edge.elementAt(k)).y-j;
                        d=Math.sqrt(dx*dx+dy*dy);
                        if (d<min_d) {
                            min_id=k;
                            min_d=d;
                        }
                    }
                }
                Dist[i][j] = min_d;
                pre_id = min_id;         // OID
	    }
        }
        // ---------------------------------------------------------------------
        while (edge.size() > 0) {
            // Imp(p)ԑ傫p0߂
            Point p0 = new Point(0,0);
            for (int j=0; j<height; j++)
                for (int i=0; i<width; i++)
                    if (Imp[i][j] > Imp[p0.x][p0.y]) {
                        p0.x = i; p0.y = j;
                    }
            double radians = grad.getDirection(p0.x,p0.y);
            int ceil = (int)Math.ceil(radians);
            int floor = (int)Math.floor(radians);
            Point s1,s2;
            double dx = d_sites*Math.cos(radians);
            double dy = d_sites*Math.sin(radians);
            double r = Math.sqrt(dx*dx+dy*dy);
            s1 = new Point((int)(p0.x+dx),(int)(p0.y+dy));
            s2 = new Point((int)(p0.x-dx),(int)(p0.y-dy));
            if ((Imp[s1.x][s1.y] < t_imp) && (Imp[s2.x][s2.y] < t_imp)) {
                kp[kpnum++] = s1;
                kp[kpnum++] = s2;
            }
            else {
                double max_d = Dist[s1.x][s1.y];
                for (int j=p0.y-d_sites; j<=p0.y+d_sites; j++) {
                    for (int i=p0.x-d_sites; i<=p0.x+d_sites; i++) {
                        if ((i>=0 && i<width) && (j>=0 && j<height)) {
                            double radians2 = Math.atan2((double)j,(double)i);
                            if ((radians2 >= floor ) && (radians2 <= ceil)) {
                                dx = p0.x-i;
                                dy = p0.y-j;
                                r = Math.sqrt(dx*dx+dy*dy);
                                if (Dist[i][j] > max_d && r >= d_min) {
                                    max_d = Dist[i][j];
                                    s1 = new Point(i,j);
                                }
                            }
                        }
                    }
                }
                s2 = new Point(2*p0.x-s1.x,2*p0.y-s1.y);
                kp[kpnum++] = s1;
                kp[kpnum++] = s2;
            }
            // s1̎͂̍W_zus\ɂ ----------------------------
            for (int j=(int)(s1.y-r); j<=s1.y+r; j++) {
                for (int i=(int)(s1.x-r); i<=s1.x+r; i++) {
                    if ((i>=0 && i<width) && (j>=0 && j<height)) {
                        dx = s1.x-i;
                        dy = s1.y-j;
                        double d = Math.sqrt(dx*dx+dy*dy);
                        if (d <= r)
                            Occ[i][j] = false;
                    }
                }
            }
            // s2̎͂̍W_zus\ɂ ----------------------------
            for (int j=(int)(s2.y-r); j<=s2.y+r; j++) {
                for (int i=(int)(s2.x-r); i<=s2.x+r; i++) {
                    if ((i>=0 && i<width) && (j>=0 && j<height)) {
                        dx = s1.x-i;
                        dy = s1.y-j;
                        double d = Math.sqrt(dx*dx+dy*dy);
                        if (d <= r)
                            Occ[i][j] = false;
                    }
                }
            }
            // GbW߂̃sNZImp(p)炷 ----------------------------
            int max_x,max_y,min_x,min_y;
            if (s1.x > s2.x) {
                max_x = s1.x; min_x = s2.x;
            }
            else {
                 max_x = s2.x; min_x = s1.x;
            }
            if (s1.y > s2.y) {
                max_y = s1.y; min_y = s2.y;
            }
            else {
                max_y = s2.y; min_y = s1.y;
            }
            int imp = Imp[p0.x][p0.y];
            for (int j=(int)(min_y-2*r); j<max_y+2*r; j++) {
                for (int i=(int)(min_x-2*r); i<max_x+2*r; i++) {
                    if ((i>=0 && i<width) && (j>=0 && j<height)) {
                        dx = s1.x-i;
                        dy = s1.y-j;
                        double d_s1 = Math.sqrt(dx*dx+dy*dy);
                        dx = s2.x-i;
                        dy = s2.y-j;
                        double d_s2 = Math.sqrt(dx*dx+dy*dy);
                        if (d_s1 <= 2*r && d_s2 <= 2*r) {
                            dx = p0.x-i;
                            dy = p0.y-j;
                            double d_p0 = Math.sqrt(dx*dx+dy*dy);
                            if (d_p0 != 0)  Imp[i][j] -= (int)(imp/d_p0);
                            else            Imp[i][j] = 0;
                        }
                    }
                }
            }
            // GbW̏C ----------------------------------------------------
            for (int i=0; i<edge.size(); i++) {
                Point p = (Point)edge.elementAt(i);
                if (Imp[p.x][p.y] < t_imp) {
                    edge.removeElementAt(i);
                    i--;
                }
            }
        }
        return kpnum;
    }
    //------------------------------------------------------------------------//
    
    //------------------------------------------------------------------------//
    // ȉ̓{mC摜𗘗p摜̕`Ɋւ郁\bhQ
    //------------------------------------------------------------------------//
    //------------------------------------------------------------------------//
    // ȉ̓Z敗̉摜̕`Ɋւ郁\bhQ
    //------------------------------------------------------------------------//
    private int cellid[];               // ZID
    private int cellnum;                // Z
    private AverageColor cellcolor[];   // ZF
    
    // Z敗̉摜`惁\bh
    public void cellDraw() {
        // ZID_IDŏ
        cellid = new int[num];
        for (int i=0; i<num; i++)
            cellid[i] = i;
        // Z̏
        cellnum = 0;
        // ZF̐ݒ
        //setCellColor();
        setCellColor2();
        
        baseAI.repaintAll();
        baseAI.update();
        if (BorderLine) {
            for (int y=0; y<baseAI.getHeight(); y++) {
                for (int x=0; x<baseAI.getWidth(); x++) {
                    int ID = cellid[dv.getDiscretePlaneID(x,y)];
                    int R = cellcolor[ID].getR();
                    int G = cellcolor[ID].getG();
                    int B = cellcolor[ID].getB();
                    baseAI.setRGB(x,y,R,G,B);
                    //baseAI.update();
                    if (x-1 >= 0)
                        if (ID != cellid[dv.getDiscretePlaneID(x-1,y)])
                            baseAI.setRGB(x,y,0,0,0);
                    if (x+1 < baseAI.getWidth())
                        if (ID != cellid[dv.getDiscretePlaneID(x+1,y)])
                            baseAI.setRGB(x,y,0,0,0);
                    if (y-1 >= 0)
                        if (ID != cellid[dv.getDiscretePlaneID(x,y-1)])
                            baseAI.setRGB(x,y,0,0,0);
                    if (y+1 < baseAI.getHeight())
                        if (ID != cellid[dv.getDiscretePlaneID(x,y+1)])
                            baseAI.setRGB(x,y,0,0,0);
                }
                this.switchThread();	//ύXʂɔf
            }
            this.switchThread();	//ύXʂɔf
        }
        else {
            for (int y=0; y<baseAI.getHeight(); y++) {
                for (int x=0; x<baseAI.getWidth(); x++) {
                    int ID = cellid[dv.getDiscretePlaneID(x,y)];
                    int R = cellcolor[ID].getR();
                    int G = cellcolor[ID].getG();
                    int B = cellcolor[ID].getB();
                    baseAI.setRGB(x,y,R,G,B);
                    //baseAI.update();
                }
                this.switchThread();	//ύXʂɔf
            }
            this.switchThread();	//ύXʂɔf
        }
        baseAI.repaintAll();
	return;	
    }
    
    // Z̐Fݒ肷郁\bh(臒l̃{mC𓝍j
    private void setCellColor() {
        // ZIDƃZ߂
        for (int i=0; i<num; i++) {
            KernelPoint KP1 = dv.getKernelPoint(i);
            if (i == cellid[i] && KP1.Color.getNum() > 0) {
                cellid[i] = cellnum;        // ZID̐ݒ
                int R = KP1.Color.getR();
                int G = KP1.Color.getG();
                int B = KP1.Color.getB();
                for (int j=i+1; j<num; j++) {
                    KernelPoint KP2 = dv.getKernelPoint(j);
                    if (j == cellid[j] && KP2.Color.getNum() > 0) {
                        if ((R-this.thre_cell <= KP2.Color.getR() && R+this.thre_cell >= KP2.Color.getR()) && 
                            (G-this.thre_cell <= KP2.Color.getG() && G+this.thre_cell >= KP2.Color.getG()) && 
                            (B-this.thre_cell <= KP2.Color.getB() && B+this.thre_cell >= KP2.Color.getB())) {
                            cellid[j] = cellnum;
                        }
                    }
                }
                cellnum++;
            }
        }
        // Z̐F̐ݒ
        cellcolor = new AverageColor[cellnum];
        for (int i=0; i < cellnum; i++) 
            cellcolor[i] = new AverageColor();
        for (int i=0; i < num; i++) {
            KernelPoint KP = dv.getKernelPoint(i);
            if (KP.Color.getNum() > 0) {
                int ID = cellid[i];
                int R = KP.Color.getR();
                int G = KP.Color.getG();
                int B = KP.Color.getB();
                cellcolor[ID].addRGB(R,G,B);
            }
        }
    }
    
    // Z̐Fݒ肷郁\bh(臒lłאڂ{mC𓝍j
    private void setCellColor2() {
        // ZIDƃZ߂
        for (int i=0; i<num; i++) {
            KernelPoint KP1 = dv.getKernelPoint(i);
            if (i >= cellid[i] && KP1.Color.getNum() > 0) {
                if (i == cellid[i]) {
                    cellid[i] = cellnum;        // ZID̐ݒ
                    cellnum++;
                }
                int R = KP1.Color.getR();
                int G = KP1.Color.getG();
                int B = KP1.Color.getB();
                for (int j=0; j < KP1.getNextIDNum(); j++) {
                    int next = KP1.getNextID(j);
                    KernelPoint KP2 = dv.getKernelPoint(next);
                    if (next >= cellid[next] && KP2.Color.getNum() > 0) {
                        if ((R-this.thre_cell <= KP2.Color.getR() && R+this.thre_cell >= KP2.Color.getR()) && 
                            (G-this.thre_cell <= KP2.Color.getG() && G+this.thre_cell >= KP2.Color.getG()) && 
                            (B-this.thre_cell <= KP2.Color.getB() && B+this.thre_cell >= KP2.Color.getB())) {
                            cellid[next] = cellid[i];
                        }
                    }
                }
            }
        }
        // Z̐F̐ݒ
        cellcolor = new AverageColor[cellnum];
        for (int i=0; i < cellnum; i++) 
            cellcolor[i] = new AverageColor();
        for (int i=0; i < num; i++) {
            KernelPoint KP = dv.getKernelPoint(i);
            if (KP.Color.getNum() > 0) {
                int ID = cellid[i];
                int R = KP.Color.getR();
                int G = KP.Color.getG();
                int B = KP.Color.getB();
                cellcolor[ID].addRGB(R,G,B);
            }
        }
    }
    //------------------------------------------------------------------------//
    
    // {mC摜`悷
    private void draw(AnimatedImage AI) {
	// 摜̃TCY擾
	width = AI.getWidth();
	height = AI.getHeight();

	// _W
	if (KPFLAG == RANDOM)       randomKernelPoint();
        else if (KPFLAG == LATTICE) {
            if ((num = latticeKernelPoint(space)) == -1) return;
        }
        else if (KPFLAG == ADAPTIVE)
            num = adaptiveKernelPoint(AI);
	// p[^̏
	initParam(num);
	// {mC̏
	dv = new DiscreteVoronoi(num, width, height);
	// _Wݒ
	for (int i=0; i<num; i++)
	    dv.setKernelPoint(kp[i].x,kp[i].y,i);
	// {mC
	dv.VoronoiDivide();

	/*for (int j=0; j<height; j++) {
	    String s = "";
	    for (int i=0; i<width; i++) {
		int ID = dv.getDiscretePlaneID(i,j);
		s = s+(char)('A'+ID);
	    }
	    ta.append(s);
	}

	for (int j=0; j<height; j++) {
	    for (int i=0; i<width; i++) {
	        int ID = dv.getDiscretePlaneID(i,j);
	        System.out.print((char)('A'+ID));
	    }
	    System.out.println();
	}*/

	for (int y=0; y<height; y++) {
	    for (int x=0; x<width; x++) {
		int ID = dv.getDiscretePlaneID(x,y);
		int R = AI.getR(x,y);
		int G = AI.getG(x,y);
		int B = AI.getB(x,y);
                KernelPoint KP = dv.getKernelPoint(ID);
		KP.Color.addRGB(R,G,B);
	    }
	}
	
	AI.repaintAll();
        if (BorderLine) {
            for (int y=0; y<AI.getHeight(); y++) {
                for (int x=0; x<AI.getWidth(); x++) {
                    int ID = dv.getDiscretePlaneID(x,y);
                    KernelPoint KP = dv.getKernelPoint(ID);
                    int R = KP.Color.getR();
                    int G = KP.Color.getG();
                    int B = KP.Color.getB();
                    AI.setRGB(x,y,R,G,B);
                    if (x-1 >= 0)
                        if (ID != dv.getDiscretePlaneID(x-1,y))
                            AI.setRGB(x,y,0,0,0);
                    if (x+1 < AI.getWidth())
                        if (ID != dv.getDiscretePlaneID(x+1,y))
                            AI.setRGB(x,y,0,0,0);
                    if (y-1 >= 0)
                        if (ID != dv.getDiscretePlaneID(x,y-1))
                            AI.setRGB(x,y,0,0,0);
                    if (y+1 < AI.getHeight())
                        if (ID != dv.getDiscretePlaneID(x,y+1))
                            AI.setRGB(x,y,0,0,0);
                }
                this.switchThread();	//ύXʂɔf
            }
            this.switchThread();	//ύXʂɔf
        }
        else {
            for (int y=0; y<AI.getHeight(); y++) {
                for (int x=0; x<AI.getWidth(); x++) {
                    int ID = dv.getDiscretePlaneID(x,y);
                    KernelPoint KP = dv.getKernelPoint(ID);
                    int R = KP.Color.getR();
                    int G = KP.Color.getG();
                    int B = KP.Color.getB();
                    AI.setRGB(x,y,R,G,B);
                }
                this.switchThread();	//ύXʂɔf
            }
            this.switchThread();	//ύXʂɔf
        }
        AI.repaintAll();
        return;	
    }
    
    /*
    public void redraw() {
	// 摜̃Zbg
	baseAI.repaintAll();
	for (int y=0; y<baseAI.getHeight(); y++) {
	    for (int x=0; x<baseAI.getWidth(); x++) {
		baseAI.resetPixel( x, y );
	    }
	    this.switchThread();	//ύXʂɔf
	}
	this.switchThread();	//ύXʂɔf
	baseAI.repaintAll();
	
	// {mC摜̕`
	draw();
	return;	
    }
     */	
	
    /** tB^̖̂Ԃ */
    public String getName()
    {
	return "Voronoi";
    }
    
    /** 摜̃tB^O */
    public void filter(AnimatedImage AI)
    {
	baseAI = AI;
        draw(AI);
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new FilterVoronoiPanel(num,space,KPFLAG,thre_cell);
    }

    ////////////////////////////////////////////////////////////////////////////
    //{mCtB^p̃plNXiCiNXj
    class FilterVoronoiPanel extends FilterPanel implements AdjustmentListener, ItemListener, ActionListener {
        private Label lb0,lb1,lb2,lb3,lb4;
        private TextField tf1,tf2,tf3;
        private Scrollbar sb1,sb2,sb3;
        private CheckboxGroup cbg1;
        private Checkbox cb[];
        //private ButtonGroup btg1;
        //private JToggleButton jbt[];
        private Button bt[];
        private int KPFLAG;
        private Checkbox cb_bl;
    
        FilterVoronoiPanel(int kpnum, int kpspace, int kpflag, int thre_cell) {
            this.lb0 = new Label("Voronoi parameter"); 
            this.lb1 = new Label("Kernel Point Number");
            this.lb2 = new Label("1/2 Space between Kernel Points");
            this.lb4 = new Label("Kernel Point Kind");
            this.lb3 = new Label("Threshold value for cell");
            this.tf1 = new TextField(""+kpnum,5);
            this.tf2 = new TextField(""+kpspace,5);
            this.tf3 = new TextField(""+thre_cell,5);
            this.sb1 = new Scrollbar(Scrollbar.HORIZONTAL,kpnum,1,1,FilterVoronoi.MAXNUM+1);
            this.sb2 = new Scrollbar(Scrollbar.HORIZONTAL,kpspace,1,2,31);
            this.sb3 = new Scrollbar(Scrollbar.HORIZONTAL,thre_cell,1,1,256);
            //Panel pl1 = new Panel();
            //pl1.setLayout(new GridLayout(FilterVoronoi.STATENUM+1,1));
            this.cbg1 = new CheckboxGroup();
            this.cb = new Checkbox[FilterVoronoi.STATENUM];
            this.cb[FilterVoronoi.RANDOM] = new Checkbox("Random", cbg1, true);
            this.cb[FilterVoronoi.LATTICE] = new Checkbox("Lattice", cbg1, false);
            //this.cb[FilterVoronoi.ADAPTIVE] = new Checkbox("Adaptive",cbg1, false);
            //pl1.add(this.lb4);
            //for (int i=0; i < FilterVoronoi.STATENUM; i++)
            //    pl1.add(this.cb[i]);
            //this.btg1 = new ButtonGroup();
            //this.jbt = new JToggleButton[FilterVoronoi.KINDNUM];
            //this.jbt[FilterVoronoi.CELL] = new JToggleButton("Cell");
            //this.btg1.add(jbt[FilterVoronoi.CELL]);
            this.bt = new Button[FilterVoronoi.KINDNUM];
            this.bt[FilterVoronoi.CELL] = new Button("Cell");
            this.cb_bl = new Checkbox("Border Line");
            this.KPFLAG = kpflag;

            this.setLayout(new GridLayout(20,1));
            this.add(new Container());
            this.add(this.lb0);
            this.add(this.cb_bl);
            this.add(this.lb1);
            this.add(this.sb1);
            sb1.addAdjustmentListener(this);
            this.add(this.tf1);
            this.add(this.lb2);
            this.add(this.sb2);
            sb2.addAdjustmentListener(this);
            this.add(this.tf2);
            //this.add(pl1);
            this.add(this.lb4);
            for (int i=0; i < FilterVoronoi.STATENUM; i++) {
                this.add(this.cb[i]);
                cb[i].addItemListener(this);
            }
            this.add(this.lb3);
            this.add(this.sb3);
            sb3.addAdjustmentListener(this);
            this.add(this.tf3);
            //for (int i=0; i < FilterVoronoi.KINDNUM; i++) {
            //    this.add(this.jbt[i]);
            //    jbt[i].addActionListener(this);
            //}
            for (int i=0; i < FilterVoronoi.KINDNUM; i++) {
                this.add(this.bt[i]);
                bt[i].addActionListener(this);
            }
        
            setItemsEnabled(FilterVoronoi.RANDOM);
        }
    
        //Item̎gp\̐ݒ胁\bh
        private void setItemsEnabled(int state) {
            boolean b1=true, b2=false;
            if (state == FilterVoronoi.RANDOM) {
                b1 = true; b2 = false;
            }
            else if (state == FilterVoronoi.LATTICE) {
                b1 = false; b2 = true;
            }
            else if (state == FilterVoronoi.ADAPTIVE) {
                b1 = false; b2 = false;
            }
            //this.lb1.setEnabled(b1);
            this.sb1.setEnabled(b1);
            this.tf1.setEnabled(b1);
            //this.lb2.setEnabled(b2);
            this.sb2.setEnabled(b2);
            this.tf2.setEnabled(b2);
        }
	
        // tB^̃p[^擾ݒ肷
        public void setFilterParameter() {
            if (cb[FilterVoronoi.RANDOM].getState()) 
                KPFLAG = FilterVoronoi.RANDOM;
            else if (cb[FilterVoronoi.LATTICE].getState()) 
                KPFLAG = FilterVoronoi.LATTICE;
            else if (cb[FilterVoronoi.ADAPTIVE].getState())
                KPFLAG = FilterVoronoi.ADAPTIVE;
            // tB^Ƀp[^ݒ
            setParam(Integer.parseInt(tf1.getText()),Integer.parseInt(tf2.getText()),KPFLAG,cb_bl.getState());
        }

        public void adjustmentValueChanged(AdjustmentEvent ae) {
            int val;
            Scrollbar se = (Scrollbar) ae.getSource();
            if (se == sb1) {
                val = sb1.getValue();
                tf1.setText(""+val);
            }
            else if (se == sb2) {
                val = sb2.getValue();
                tf2.setText(""+val);
            }
            else if (se == sb3) {
                val = sb3.getValue();
                tf3.setText(""+val);
            }
        }
    
        public void itemStateChanged(ItemEvent ie) {
            Checkbox cb = (Checkbox)ie.getItemSelectable();
            if (cb == this.cb[FilterVoronoi.RANDOM]) {
                setItemsEnabled(FilterVoronoi.RANDOM);
            }
            else if (cb == this.cb[FilterVoronoi.LATTICE]) {
                setItemsEnabled(FilterVoronoi.LATTICE);
            }
            else if (cb == this.cb[FilterVoronoi.ADAPTIVE]) {
                setItemsEnabled(FilterVoronoi.ADAPTIVE);
            }
        }
    
        public void actionPerformed(ActionEvent ae) {
            Button bt = (Button)ae.getSource();
            if (bt == this.bt[FilterVoronoi.CELL]) {
                setThresholdforCell(Integer.parseInt(tf3.getText()));
                setBorderLine(cb_bl.getState());
                cellDraw();
            }
        }
    }
    ////////////////////////////////////////////////////////////////////////////
}
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// G[\t[
class ErrorFrame extends Frame implements ActionListener {
    ErrorFrame(String title) {
        super(title);
        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent we) {
                dispose();
            }
        });
    }
    
    public void setErrorMessage(String message) {
        this.setLayout(new GridLayout(2,1,50,30));
        this.add(new Label(message));
        Button b = new Button("Close");
        this.add(b);
        b.addActionListener(this);
        b.setSize(60,30);
    }
    
    public void actionPerformed(ActionEvent ae) {
        dispose();
    }
}
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// RGBl̕ςǗNX
class AverageColor {
    private int totalR, totalG, totalB;    // RGBl̊ev
    private int totalNum;                  // vsNZ

    // RXgN^
    public AverageColor() {
	this.totalR = 0;
	this.totalG = 0;
	this.totalB = 0;
	this.totalNum = 0;
    }

    // RGBl
    public void addRGB(int R, int G, int B) {
	totalR += R;
	totalG += G;
	totalB += B;
	totalNum++;
    }

    // Rl̕ςԂ
    public int getR() { return (int)(totalR / totalNum); }
    // Gl̕ςԂ
    public int getG() { return (int)(totalG / totalNum); }
    // Bl̕ςԂ
    public int getB() { return (int)(totalB / totalNum); }
    // vsNZԂ
    public int getNum() { return totalNum; }
}
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// _NX
class KernelPoint {
    public int X, Y, ID;
    public AverageColor Color;
    private Vector NextID;      // אڂ_ID
    
    public KernelPoint() {
        this.Color = new AverageColor();
        this.NextID = new Vector();
    }
    
    public KernelPoint(int X, int Y, int ID) {
        this.X = X;
        this.Y = Y;
        this.ID = ID;
        this.Color = new AverageColor();
        this.NextID = new Vector();
    }
    
    public void setNextID(int ID) {
        Integer i = new Integer(ID);
        if (!NextID.contains(i))
            NextID.add(i);
    }
    
    public int getNextIDNum() {
        return NextID.size();
    }
    
    public int getNextID(int index) {
        return ((Integer)NextID.elementAt(index)).intValue();
    }
    
    public int[] getNextID() {
        int id[] = new int[NextID.size()];
        for (int i=0; i < NextID.size(); i++)
            id[i] = ((Integer)NextID.elementAt(i)).intValue();
        return id;
    }
}
////////////////////////////////////////////////////////////////////////////////
/*
////////////////////////////////////////////////////////////////////////////////
// ꎟiOfBGgj
class Gradient{
    private int target[][];                             // Ώۉ摜̒l
    private int grad[][];                               // Ώۉ摜̌zl
    private int dx[][],dy[][];                              // x,y̍
    private int width,height;                           // Ώۉ摜̕ƍ
    private int filterX[] = {-1,0,1,-2,0,2,-1,0,1};     // SobelIy[^xp
    private int filterY[] = {-1,-2,-1,0,0,0,1,2,1};     // SobelIy[^yp
    
    public Gradient(AnimatedImage AI) {
        this.width = AI.getWidth();
        this.height = AI.getHeight();
        //this.target = new int[width+2][height+2];
        this.target = new int[width][height];
        this.grad = new int[width][height];
        this.dx = new int[width][height];
        this.dy = new int[width][height];
        /*
        // Ώۉ摜O̒lݒ
        for (int i=0; i<width+2; i++) {
            target[i][0] = 0;
            target[i][height+1] = 0;
        }
        for (int j=0; j<height; j++) {
            target[0][j] = 0;
            target[width+1][j] = 0;
        }
         */
        // Ώۉ摜O[XP[Ƃĕێ
        for (int j=0; j<height; j++) {
            for (int i=0; i<width; i++) {
                //target[i+1][j+1] = changeGrayScale(AI.getR(i,j),AI.getG(i,j),AI.getB(i,j));
                target[i][j] = changeGrayScale(AI.getR(i,j),AI.getG(i,j),AI.getB(i,j));
            }
        }
    }
    
    // J[(R,G,B)O[XP[ɕϊ郁\bh
    private int changeGrayScale(int R, int G, int B) {
        return (int)((R + G + B) / 3);
    }
    
    // zlԂ
    public int[][] getGradientValue() {
        /*
        for (int j=0; j<height; j++) {
            for (int i=0; i<width; i++) {
                int dx = filterX[0]*target[i][j]+filterX[1]*target[i+1][j]+filterX[2]*target[i+2][j]
                        +filterX[3]*target[i][j+1]+filterX[4]*target[i+1][j+1]+filterX[5]*target[i+2][j+1]
                        +filterX[6]*target[i][j+2]+filterX[7]*target[i+1][j+2]+filterX[8]*target[i+2][j+2];
                int dy = filterY[0]*target[i][j]+filterY[1]*target[i+1][j]+filterY[2]*target[i+2][j]
                        +filterY[3]*target[i][j+1]+filterY[4]*target[i+1][j+1]+filterY[5]*target[i+2][j+1]
                        +filterY[6]*target[i][j+2]+filterY[7]*target[i+1][j+2]+filterY[8]*target[i+2][j+2];
                grad[j*width+i] = (int)Math.sqrt(Math.pow(dx,2)+Math.pow(dy,2));
            }
        }
         */
        for (int i=0; i<width; i++) {
            target[i][0] = 0;
            target[i][height-1] = 0;
        }
        for (int j=0; j<height; j++) {
            target[0][j] = 0;
            target[width-1][j] = 0;
        }
        for (int j=1; j<height-1; j++) {
            for (int i=1; i<width-1; i++) {
                dx[i][j] = filterX[0]*target[i-1][j-1]+filterX[1]*target[i][j-1]+filterX[2]*target[i+1][j-1]
                            +filterX[3]*target[i-1][j]+filterX[4]*target[i][j]+filterX[5]*target[i+1][j]
                            +filterX[6]*target[i-1][j+1]+filterX[7]*target[i][j+1]+filterX[8]*target[i+1][j+1];
                dy[i][j] = filterY[0]*target[i-1][j-1]+filterY[1]*target[i][j-1]+filterY[2]*target[i+1][j-1]
                            +filterY[3]*target[i-1][j]+filterY[4]*target[i][j]+filterY[5]*target[i+1][j]
                            +filterY[6]*target[i-1][j+1]+filterY[7]*target[i][j+1]+filterY[8]*target[i+1][j+1];
                grad[i][j] = (int)Math.sqrt(Math.pow(dx[i][j],2)+Math.pow(dy[i][j],2));
            }
        }
        return grad;
    }
    
    // Ԃ
    public double getDirection(int x, int y) {
        return Math.atan2((double)dy[x][y],(double)dx[x][y]);
    }
}
////////////////////////////////////////////////////////////////////////////////
 */
////////////////////////////////////////////////////////////////////////////////
//
//  ȉ͓񎟂̗U{mCɊւNXQ
//  ̃vO͈ȉWeby[W̃ASYQlɂ
//  http://www.ics.kagoshima-u.ac.jp/~fuchida/edu/algorithm/voronoi-diagram/all-search-method.html
//
// U{mC̃NX	
class DiscreteVoronoi {
    private int N;                  // _
    private KernelPoint kp[];       // _
    private int W, H;               // Uʂ̑傫
    private int ds[][];             // U
    private boolean SortFlag;           // \[gĂ邩̃tO
    
    // RXgN^
    DiscreteVoronoi(int N, int W, int H) {
	this.N = N;
	this.W = W;
	this.H = H;
        this.kp = new KernelPoint[N];
	this.ds = new int[W][H];
	
	// Uʂ̏
	for (int i=0; i<W; i++)
	    for (int j=0; j<H; j++)
		ds[i][j] = -1;
        
        // \[gtȌ
        SortFlag = false;
    }
    
    // _ݒ肷֐
    public void setKernelPoint(int X, int Y, int ID) {
	kp[ID] = new KernelPoint(X,Y,ID);
    }
    
    // _擾֐
    public KernelPoint getKernelPoint(int ID) {
        return kp[ID];
    }
    
    // Uʂ̊eWIDԂ֐
    public int getDiscretePlaneID(int X, int Y) {
	return ds[X][Y];
    }
    
    // {mC֐
    public void VoronoiDivide() {
	int i;
        if (!SortFlag) quickSort(0,this.N-1);
        for (i=0; i<N; i++) {
	    if (kp[i].ID == -1)  break;
	}
	if (i == N)  calculateDiscretePlaneID();
    }
    
    // Uʂ̊eWIDvZ֐
    private void calculateDiscretePlaneID() {
        /* ׂĂ̗U_ɂă[v
	for (int j=0;j<H;j++) {		// ׂĂ̗U_ɂ
	    for (int i=0;i<W;i++) {	// [v܂킵Ă
		
		/* ł߂_̌
                double min_d=Double.MAX_VALUE;	// ŏ
		int min_id=-1;			// ŏ_ ID
		for (int k=0;k<N;k++) {		// ׂĂ̕_ɂ
		    double dx=x[k]-i;
		    double dy=y[k]-j;		// U_Ƃ̋vZA
		    double d=Math.sqrt(dx*dx+dy*dy);
		    if (d<min_d) {			// ꂪ܂ł̍ŏ
			min_id=k;		// ΁Aŏl
			min_d=d;		// XV
		    }
		}
		ds[i][j]=min_id;	// ŏ ID 
	    }
	}
        */
        int min_id = 0;                 // ŏ̕_ID
        int pre_id = 0;                 // OsNZ̕_ID 
        for (int j=0;j<H;j++) {
	    for (int i=0;i<W;i++) {
		/* ł߂_̌
                 */
                // OsNZ̕_Ƃ̋߂
                double d;
                double dx=kp[pre_id].X-i;
                double dy=kp[pre_id].Y-j;
                double min_d=Math.sqrt(dx*dx+dy*dy);
                //boolean UpdateFlag = false;     // XVtO
                // ݂̃sNZ̉Eɂ߂_邩
		for (int k=pre_id-1; k>=0 && (kp[k].Y>=j-min_d);k--) {
		    if (kp[k].X >= i && kp[k].X <= i+min_d) {
                        dx=kp[k].X-i;
                        dy=kp[k].Y-j;
                        d=Math.sqrt(dx*dx+dy*dy);
                        if (d<min_d) {
                            //min_id=id[k];
                            min_id=k;
                            min_d=d;
                            //UpdateFlag = true;
                            //break;
                        }
                    }
		}
                // ݂̃sNZ̉Eɂ߂_邩
                //if (!UpdateFlag) {      // EŌȂ
                    for (int k=pre_id+1; k<N && (kp[k].Y<=j+min_d);k++) {
                        if (kp[k].X >= i && kp[k].X <= i+min_d) {
                            dx=kp[k].X-i;
                            dy=kp[k].Y-j;
                            d=Math.sqrt(dx*dx+dy*dy);
                            if (d<min_d) {
                                //min_id=id[k];
                                min_id=k;
                                min_d=d;
                                //break;
                            }
                        }
                    }
                //}
                // אIDݒ肷
                if (pre_id != min_id) {
                    kp[pre_id].setNextID(min_id);
                    kp[min_id].setNextID(pre_id);
                }
		ds[i][j] = min_id;	// ŏ ID 
                pre_id = min_id;         // OID
	    }
	}
    }
    
    // NCbN\[g
    private void quickSort(int left, int right) {
        int last;
        if (left >= right) {
            SortFlag = true;
            return;
        }
        swap(left, (left+right)/2);   
        last = left;
        for (int i = left+1; i <= right; i++) {
            if (kp[i].Y < kp[left].Y)
                swap(++last, i);
            else if ((kp[i].Y == kp[left].Y) && (kp[i].X < kp[left].X))
                swap(++last, i);
        }
        swap(left, last);
        quickSort(left, last-1);
        quickSort(last+1, right);
    }
    // Xbvp֐
    private void swap(int i, int j) {
        int tmp;
        // xW̓ꊷ
        tmp = kp[i].X; kp[i].X = kp[j].X; kp[j].X = tmp;
        // yW̓ꊷ
        tmp = kp[i].Y; kp[i].Y = kp[j].Y; kp[j].Y = tmp;
        // id̓ꊷ
        //tmp = id[i]; id[i] = id[j]; id[j] = tmp;
    }
}
////////////////////////////////////////////////////////////////////////////////